



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>前端MVC Vue2学习总结（六）——axios与跨域HTTP请求、Lodash工具库</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">前端MVC Vue2学习总结（六）——axios与跨域HTTP请求、Lodash工具库</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-29 18:04:48 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h1>一、axios</h1>
<p>Vue更新到2.0之后宣告不再对vue-resource更新，推荐使用axios，axios是一个用于客户端与服务器通信的组件，axios 是一个基于Promise 用于浏览器和 nodejs 的 HTTP 客户端javaScript工具。通俗来说可以实现客户端请求服务器端提供的服务获得数据。</p>
<p>源码与帮助：<a href="https://github.com/axios/axios" rel="external nofollow noreferrer">https://github.com/axios/axios</a></p>
<p>服务器端跨域支持请查看：<a href="http://www.cnblogs.com/best/p/6196202.html#_label2" rel="external nofollow noreferrer">http://www.cnblogs.com/best/p/6196202.html#_label2</a></p>
<h2>1.1、特点</h2>
<ul><li>从浏览器中创建 XMLHttpRequest</li>
<li>从 node.js 发出 http 请求</li>
<li>支持 Promise API</li>
<li>拦截请求和响应</li>
<li>转换请求和响应数据</li>
<li>取消请求</li>
<li>自动转换JSON数据</li>
<li>客户端支持防止 CSRF/XSRF</li></ul>
<h2>1.2、浏览器兼容性</h2>
<p><img referrerpolicy="no-referrer"src="https://images2017.cnblogs.com/blog/63651/201801/63651-20180103141107174-900071272.png" /></p>
<h2>1.3、依赖办法</h2>
<div>
<pre class="prettyprint linenums">$ npm install axios<br />
$ cnpm install axios //taobao<br />
$ bower install axios<br />
或者使用cdn：<br />
&lt;script src="https://unpkg.com/axios/dist/axios.min.js"&gt;&lt;/script&gt;</pre>
</div>
<p>浏览器可以引入js文件</p>
<h2>1.4、快速入门</h2>
<h3>1.4.0、服务器端</h3>
<p>控制器：</p>
<div>
<pre class="prettyprint linenums">package com.zhangguo.springmvc08.controller;

import com.zhangguo.springmvc08.entity.User;<br />
import com.zhangguo.springmvc08.service.UserService;<br />
import org.springframework.beans.factory.annotation.Autowired;<br />
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;<br />
import javax.servlet.http.HttpServletResponse;<br />
import java.util.List;

@RestController<br />
@RequestMapping(path = "/emps")<br />
public class EmpController extends BaseController {

    @Autowired<br />
    UserService userService;

    @RequestMapping(path = "")<br />
    public AjaxState getAllEmps(HttpServletRequest request, HttpServletResponse response) {<br />
        List&lt;User&gt; users=userService.queryAllUsers();<br />
        boolean result=users!=null;<br />
        return new AjaxState(result?"success":"error",users,result?"获得数据成功！":"获得数据失败!");<br />
    }

    @RequestMapping(path = "/{id}", method = RequestMethod.GET)<br />
    public AjaxState getEmpById(@PathVariable int id) {<br />
        User user=userService.getUserById(id);<br />
        boolean result=user!=null;<br />
        return new AjaxState(result?"success":"error",user,result?"获得数据成功！":"获得数据失败!");<br />
    }

    @RequestMapping(path = "/getEmpById", method = RequestMethod.GET)<br />
    public AjaxState getEmpById(HttpServletRequest request) {<br />
        int id=Integer.parseInt(request.getParameter("id"));<br />
        User user=userService.getUserById(id);<br />
        boolean result=user!=null;<br />
        return new AjaxState(result?"success":"error",user,result?"获得数据成功！":"获得数据失败!");<br />
    }

    @RequestMapping(path = "", method = RequestMethod.POST)<br />
    public AjaxState addEmp(@RequestBody User user) {<br />
        boolean result=userService.addUser(user);<br />
        return new AjaxState(result?"success":"error",user,result?"添加成功！":"添加失败");<br />
    }

    @RequestMapping(path = "", method = RequestMethod.PUT)<br />
    public AjaxState updateEmp(@RequestBody User user) {<br />
        boolean result=userService.editUser(user);<br />
        return new AjaxState(result?"success":"error",user,result?"修改成功！":"修改失败");<br />
    }

    @RequestMapping(path = "/{id}", method = RequestMethod.DELETE)<br />
    public AjaxState deleteEmpById(@PathVariable int id) {<br />
        Boolean result=userService.deleteUser(id);<br />
        return new AjaxState(result?"success":"error",id,result?"删除成功！":"删除失败");<br />
    }

}

class  AjaxState{<br />
    public String state;<br />
    public Object data;<br />
    public String message;

    public AjaxState(String state, Object data, String message) {<br />
        this.state = state;<br />
        this.data = data;<br />
        this.message = message;<br />
    }

    public AjaxState(){}<br />
}</pre>
</div>
<p><strong>跨域设置（任选一种）：</strong></p>
<p>方法1：Servlet，MVC都可以，Web.xml</p>
<div>
<pre class="prettyprint linenums">    &lt;filter&gt;<br />
        &lt;filter-name&gt;CORS&lt;/filter-name&gt;<br />
        &lt;filter-class&gt;com.thetransactioncompany.cors.CORSFilter&lt;/filter-class&gt;<br />
        &lt;init-param&gt;<br />
            &lt;param-name&gt;cors.allowOrigin&lt;/param-name&gt;<br />
            &lt;param-value&gt;http://127.0.0.1:8020&lt;/param-value&gt;<br />
        &lt;/init-param&gt;<br />
        &lt;init-param&gt;<br />
            &lt;param-name&gt;cors.supportedMethods&lt;/param-name&gt;<br />
            &lt;param-value&gt;POST,GET,OPTIONS,DELETE,PUT&lt;/param-value&gt;<br />
        &lt;/init-param&gt;<br />
        &lt;init-param&gt;<br />
            &lt;param-name&gt;cors.supportedHeaders&lt;/param-name&gt;<br />
            &lt;param-value&gt;Content-Type,Accept,Origin,XRequestedWith,ContentType,LastModified&lt;/param-value&gt;<br />
        &lt;/init-param&gt;<br />
        &lt;init-param&gt;<br />
            &lt;param-name&gt;cors.exposedHeaders&lt;/param-name&gt;<br />
            &lt;param-value&gt;SetCookie&lt;/param-value&gt;<br />
        &lt;/init-param&gt;<br />
        &lt;init-param&gt;<br />
            &lt;param-name&gt;cors.supportsCredentials&lt;/param-name&gt;<br />
            &lt;param-value&gt;true&lt;/param-value&gt;<br />
        &lt;/init-param&gt;<br />
    &lt;/filter&gt;

    &lt;filter-mapping&gt;<br />
        &lt;filter-name&gt;CORS&lt;/filter-name&gt;<br />
        &lt;url-pattern&gt;/*&lt;/url-pattern&gt;<br />
    &lt;/filter-mapping&gt;</pre>
</div>
<p>方法2：Spring MVC，修改Spring 配置文件，低Spring版本不支持</p>
<div>
<pre class="prettyprint linenums">    &lt;mvc:cors&gt;<br />
        &lt;mvc:mapping path="/**"<br />
                     allowed-origins="http://127.0.0.1:8020"<br />
                     allowed-methods="POST,GET, OPTIONS,DELETE,PUT"<br />
                     allowed-headers="Content-Type,ContentType,Access-Control-Allow-Headers, Authorization, X-Requested-With"<br />
                     allow-credentials="true"/&gt;<br />
    &lt;/mvc:cors&gt;</pre>
</div>
<h3>1.4.1、发送Get请求</h3>
<div>
<pre class="prettyprint linenums">//向具有指定ID的用户发出请求<br />
axios.get('/user?ID=123')<br />
.then(function (response) {<br />
console.log(response);<br />
})<br />
.catch(function (error) {<br />
　　console.log(error);<br />
});

//也可以通过 params 对象传递参数<br />
axios.get('/user', {<br />
params: {<br />
　　ID: 12345<br />
}<br />
})<br />
.then(function (response) {<br />
　　console.log(response);<br />
})<br />
.catch(function (error) {<br />
　　console.log(error);<br />
});</pre>
</div>
<p>示例：</p>
<div>
<pre class="prettyprint linenums">&lt;!DOCTYPE html&gt;<br />
&lt;html&gt;<br />
    &lt;head&gt;<br />
        &lt;meta charset="UTF-8"&gt;<br />
        &lt;title&gt;axios&lt;/title&gt;<br />
    &lt;/head&gt;<br />
    &lt;body&gt;<br />
        &lt;div id="vm"&gt;<br />
            &lt;button type="button" @click="get"&gt;Get请求&lt;/button&gt;<br />
            &lt;button type="button" @click="getParam"&gt;Get请求带参数&lt;/button&gt;<br />
            &lt;h3&gt;{{msg}}&lt;/h3&gt;<br />
        &lt;/div&gt;<br />
        &lt;script src="../js/vue.js" type="text/javascript" charset="utf-8"&gt;&lt;/script&gt;<br />
        &lt;script src="../js/axios/axios.min.js" type="text/javascript" charset="utf-8"&gt;&lt;/script&gt;<br />
        &lt;script type="text/javascript"&gt;<br />
            var vm = new Vue({<br />
                el: "#vm",<br />
                data: {<br />
                    msg: ""<br />
                },<br />
                methods: {<br />
                    get: function() {<br />
                        var that = this;<br />
                        axios.get("http://localhost:8080/mvc08/emps").then(function(response) {<br />
                            console.log(response);<br />
                            //this.msg=JSON.stringify(response.data);  //错误this指向window<br />
                            vm.msg = JSON.stringify(response.data);<br />
                            that.msg = JSON.stringify(response.data);<br />
                        }).catch(function(error) {<br />
                            console.log(error);<br />
                        })<br />
                    },<br />
                    getParam: function() {<br />
                        axios.get("http://localhost:8080/mvc08/emps/getEmpById", {<br />
                            params: {<br />
                                id: 1<br />
                            }<br />
                        }).then(function(response) {<br />
                            vm.msg = JSON.stringify(response.data);<br />
                        }).catch(function(error) {<br />
                            console.log(error);<br />
                        })<br />
                    }<br />
                }<br />
            });<br />
        &lt;/script&gt;<br />
    &lt;/body&gt;<br />
&lt;/html&gt;</pre>
</div>
<p>结果：</p>
<p>get请求</p>
<p><img referrerpolicy="no-referrer"src="https://images2017.cnblogs.com/blog/63651/201801/63651-20180103162706471-939767694.png" /></p>
<p>带参数：</p>
<p><img referrerpolicy="no-referrer"src="https://images2017.cnblogs.com/blog/63651/201801/63651-20180103162937409-133275401.png" /></p>
<p>默认的content-type为：application/json;charset=UTF-8</p>
<h3>1.4.2、发送Post请求</h3>
<div>
<pre class="prettyprint linenums">axios.post('/user', {<br />
    firstName: 'Fred',<br />
    lastName: 'Flintstone'<br />
  })<br />
  .then(function (response) {<br />
    console.log(response);<br />
  })<br />
  .catch(function (error) {<br />
    console.log(error);<br />
  });</pre>
</div>
<p>示例(添加一个用户)：</p>
<div>
<div>
<pre class="prettyprint linenums">&lt;!DOCTYPE html&gt;<br />
&lt;html&gt;

    &lt;head&gt;<br />
        &lt;meta charset="UTF-8"&gt;<br />
        &lt;title&gt;axios&lt;/title&gt;<br />
    &lt;/head&gt;

    &lt;body&gt;<br />
        &lt;div id="vm"&gt;<br />
            &lt;button type="button" @click="get"&gt;Get请求&lt;/button&gt;<br />
            &lt;button type="button" @click="getParam"&gt;Get请求带参数&lt;/button&gt;<br />
            &lt;button type="button" @click="post"&gt;Post请求带参数&lt;/button&gt;<br />
            &lt;h3&gt;{{msg}}&lt;/h3&gt;<br />
        &lt;/div&gt;<br />
        &lt;script src="../js/vue.js" type="text/javascript" charset="utf-8"&gt;&lt;/script&gt;<br />
        &lt;script src="../js/axios/axios.min.js" type="text/javascript" charset="utf-8"&gt;&lt;/script&gt;<br />
        &lt;script type="text/javascript"&gt;<br />
            var vm = new Vue({<br />
                el: "#vm",<br />
                data: {<br />
                    msg: ""<br />
                },<br />
                methods: {<br />
                    get: function() { //get请求<br />
                        var that = this;<br />
                        axios.get("http://localhost:8080/mvc08/emps").then(function(response) {<br />
                            console.log(response);<br />
                            //this.msg=JSON.stringify(response.data);  //错误this指向window<br />
                            vm.msg = JSON.stringify(response.data);<br />
                            that.msg = JSON.stringify(response.data);<br />
                        }).catch(function(error) {<br />
                            console.log(error);<br />
                        })<br />
                    },<br />
                    getParam: function() { //带参数的get<br />
                        axios.get("http://localhost:8080/mvc08/emps/getEmpById", {<br />
                            params: {<br />
                                id: 1<br />
                            }<br />
                        }).then(function(response) {<br />
                            vm.msg = JSON.stringify(response.data);<br />
                            console.log(response);<br />
                        }).catch(function(error) {<br />
                            console.log(error);<br />
                        })<br />
                    },<br />
                    post: function() { //post<br />
                        var user = {<br />
                            "id": 1,<br />
                            "name": "张一三",<br />
                            "birthday": "1998-09-08",<br />
                            "address": "中国北京",<br />
                            "phone": "18989891122"<br />
                        };

                        axios<br />
                        .post("http://localhost:8080/mvc08/emps", user)<br />
                        .then(function(response) {<br />
                            vm.msg=response.data.data;<br />
                            console.log(response);<br />
                        })<br />
                        .catch(function(error){<br />
                            console.log(error);<br />
                        });<br />
                    }<br />
                }<br />
            });<br />
        &lt;/script&gt;<br />
    &lt;/body&gt;

&lt;/html&gt;</pre>
</div>
</div>
<p>结果：</p>
<p><img referrerpolicy="no-referrer"src="https://images2017.cnblogs.com/blog/63651/201801/63651-20180104091050518-1305823352.png" /></p>
<h3>1.4.3、发送多个并发请求</h3>
<div>
<pre class="prettyprint linenums">function getUserAccount() {<br />
return axios.get('/user/12345');<br />
}

function getUserPermissions() {<br />
return axios.get('/user/12345/permissions');<br />
}

axios.all([getUserAccount(), getUserPermissions()])<br />
.then(axios.spread(function (acct, perms) {<br />
//两个请求现已完成<br />
}));</pre>
</div>
<p>示例（同时获得编号为1与编号为2的学生，通过两个请求完成）：</p>
<div>
<pre class="prettyprint linenums">&lt;!DOCTYPE html&gt;<br />
&lt;html&gt;<br />
    &lt;head&gt;<br />
        &lt;meta charset="UTF-8"&gt;<br />
        &lt;title&gt;axios&lt;/title&gt;<br />
    &lt;/head&gt;<br />
    &lt;body&gt;<br />
        &lt;div id="vm"&gt;<br />
            &lt;button type="button" @click="all"&gt;all请求（并发请求）&lt;/button&gt;<br />
            &lt;h3&gt;{{msg}}&lt;/h3&gt;<br />
        &lt;/div&gt;<br />
        &lt;script src="../js/vue.js" type="text/javascript" charset="utf-8"&gt;&lt;/script&gt;<br />
        &lt;script src="../js/axios/axios.min.js" type="text/javascript" charset="utf-8"&gt;&lt;/script&gt;<br />
        &lt;script type="text/javascript"&gt;<br />
            var vm = new Vue({<br />
                el: "#vm",<br />
                data: {<br />
                    msg: ""<br />
                },<br />
                methods: {<br />
                    all:function(){<br />
                        //获得用户对象1<br />
                        var getUser1=function(){<br />
                            return axios.get("http://localhost:8080/mvc08/emps/1");<br />
                        };<br />
                        //获得用户对象2<br />
                        var getUser2=function(){<br />
                            return axios.get("http://localhost:8080/mvc08/emps/2");<br />
                        };<br />
                        //并发请求处理结果<br />
                        axios.all([getUser1(),getUser2()])<br />
                        .then(axios.spread(function(response1,response2){<br />
                            var result="";<br />
                            result+=JSON.stringify(response1.data.data);<br />
                            result+=JSON.stringify(response2.data.data);<br />
                            vm.msg=result;<br />
                        }))<br />
                        .catch(function(error){<br />
                            console.log(error);<br />
                        });<br />
                    }<br />
                }<br />
            });<br />
        &lt;/script&gt;<br />
    &lt;/body&gt;<br />
&lt;/html&gt;</pre>
</div>
<p>结果：</p>
<p><img referrerpolicy="no-referrer"src="https://images2017.cnblogs.com/blog/63651/201801/63651-20180104092159237-1309014627.png" /></p>
<h3>1.4.4、发送Put请求</h3>
<p>示例（修改编号为1的用户信息）：</p>
<div>
<pre class="prettyprint linenums">&lt;!DOCTYPE html&gt;<br />
&lt;html&gt;

    &lt;head&gt;<br />
        &lt;meta charset="UTF-8"&gt;<br />
        &lt;title&gt;axios&lt;/title&gt;<br />
    &lt;/head&gt;

    &lt;body&gt;<br />
        &lt;div id="vm"&gt;<br />
            &lt;button type="button" @click="all"&gt;all请求（并发请求）&lt;/button&gt;<br />
            &lt;button type="button" @click="put"&gt;put请求（修改数据）&lt;/button&gt;<br />
            &lt;h3&gt;{{msg}}&lt;/h3&gt;<br />
        &lt;/div&gt;<br />
        &lt;script src="../js/vue.js" type="text/javascript" charset="utf-8"&gt;&lt;/script&gt;<br />
        &lt;script src="../js/axios/axios.min.js" type="text/javascript" charset="utf-8"&gt;&lt;/script&gt;<br />
        &lt;script type="text/javascript"&gt;<br />
            var vm = new Vue({<br />
                el: "#vm",<br />
                data: {<br />
                    msg: ""<br />
                },<br />
                methods: {<br />
                    all: function() {<br />
                        //获得用户对象1<br />
                        var getUser1 = function() {<br />
                            return axios({<br />
                                url:"http://localhost:8080/mvc08/emps/1",<br />
                                method:"get"<br />
                            });<br />
                        };<br />
                        //获得用户对象2<br />
                        var getUser2 = function() {<br />
                            return axios.get("http://localhost:8080/mvc08/emps/2");<br />
                        };<br />
                        //并发请求处理结果<br />
                        axios.all([getUser1(), getUser2()])<br />
                            .then(axios.spread(function(response1, response2) {<br />
                                var result = "";<br />
                                result += JSON.stringify(response1.data.data);<br />
                                result += JSON.stringify(response2.data.data);<br />
                                vm.msg = result;<br />
                            }))<br />
                            .catch(function(error) {<br />
                                console.log(error);<br />
                            });<br />
                    },<br />
                    put: function() {<br />
                        var user = {<br />
                            "id": 1,<br />
                            "name": "张学霸",<br />
                            "birthday": "1988-09-08",<br />
                            "address": "中国珠海",<br />
                            "phone": "13223456786"<br />
                        };<br />
                        axios.put("http://localhost:8080/mvc08/emps",user)<br />
                        .then(r=&gt;vm.msg=r.data.data)<br />
                        .catch(e=&gt;console.log(e));<br />
                    }<br />
                }<br />
            });<br />
        &lt;/script&gt;<br />
    &lt;/body&gt;

&lt;/html&gt;</pre>
</div>
<p>结果：</p>
<p><img referrerpolicy="no-referrer"src="https://images2017.cnblogs.com/blog/63651/201801/63651-20180104094645206-1541261876.png" /></p>
<h3>1.4.5、发送Delete请求</h3>
<p>示例（删除编号为2的用户）：</p>
<div>
<pre class="prettyprint linenums">&lt;!DOCTYPE html&gt;<br />
&lt;html&gt;

    &lt;head&gt;<br />
        &lt;meta charset="UTF-8"&gt;<br />
        &lt;title&gt;axios&lt;/title&gt;<br />
    &lt;/head&gt;

    &lt;body&gt;<br />
        &lt;div id="vm"&gt;<br />
            &lt;button type="button" @click="all"&gt;all请求（并发请求）&lt;/button&gt;<br />
            &lt;button type="button" @click="remove"&gt;delete请求（删除数据）&lt;/button&gt;<br />
            &lt;h3&gt;{{msg}}&lt;/h3&gt;<br />
        &lt;/div&gt;<br />
        &lt;script src="../js/vue.js" type="text/javascript" charset="utf-8"&gt;&lt;/script&gt;<br />
        &lt;script src="../js/axios/axios.min.js" type="text/javascript" charset="utf-8"&gt;&lt;/script&gt;<br />
        &lt;script type="text/javascript"&gt;<br />
            var vm = new Vue({<br />
                el: "#vm",<br />
                data: {<br />
                    msg: ""<br />
                },<br />
                methods: {<br />
                    all: function() {<br />
                        //获得用户对象1<br />
                        var getUser1 = function() {<br />
                            return axios({<br />
                                url:"http://localhost:8080/mvc08/emps/1",<br />
                                method:"get"<br />
                            });<br />
                        };<br />
                        //获得用户对象2<br />
                        var getUser2 = function() {<br />
                            return axios.get("http://localhost:8080/mvc08/emps/2");<br />
                        };<br />
                        //并发请求处理结果<br />
                        axios.all([getUser1(), getUser2()])<br />
                            .then(axios.spread(function(response1, response2) {<br />
                                var result = "";<br />
                                result += JSON.stringify(response1.data.data);<br />
                                result += JSON.stringify(response2.data.data);<br />
                                vm.msg = result;<br />
                            }))<br />
                            .catch(function(error) {<br />
                                console.log(error);<br />
                            });<br />
                    },<br />
                    remove: function() {<br />
                        axios.delete("http://localhost:8080/mvc08/emps/2")<br />
                        .then(r=&gt;vm.msg=r.data.data)<br />
                        .catch(e=&gt;console.log(e));<br />
                    }<br />
                }<br />
            });<br />
        &lt;/script&gt;<br />
    &lt;/body&gt;

&lt;/html&gt;</pre>
</div>
<p>结果：</p>
<p><img referrerpolicy="no-referrer"src="https://images2017.cnblogs.com/blog/63651/201801/63651-20180104095147331-289910208.png" /></p>
<h2>1.3、帮助说明（API）</h2>
<p>可以通过将相关配置传递给 axios 来进行请求。</p>
<h3>1.3.1、axios(config)</h3>
<div>
<pre class="prettyprint linenums">//发送一个 POST 请求<br />
axios({<br />
    method: 'post',<br />
    url: '/user/12345',<br />
    data: {<br />
        firstName: 'Fred',<br />
        lastName: 'Flintstone'<br />
    }<br />
});</pre>
</div>
<h3>1.3.2、axios(url[, config])</h3>
<div>
<pre class="prettyprint linenums">// 发送一个 GET 请求 (GET请求是默认请求模式)<br />
axios('/user/12345');</pre>
</div>
<h3>1.3.3、请求方法别名</h3>
<p>为了方便起见，已经为所有支持的请求方法提供了别名。</p>
<div>
<pre class="prettyprint linenums">axios.request（config）<br />
axios.get（url [，config]）<br />
axios.delete（url [，config]）<br />
axios.head（url [，config]）<br />
axios.post（url [，data [，config]]）<br />
axios.put（url [，data [，config]]）<br />
axios.patch（url [，data [，config]]）</pre>
</div>
<p>注意当使用别名方法时，不需要在config中指定url，method和data属性。</p>
<h3>1.3.4、并发</h3>
<p>帮助函数处理并发请求。</p>
<div>
<pre class="prettyprint linenums">axios.all（iterable）<br />
axios.spread（callback）</pre>
</div>
<h3>1.3.5、创建实例</h3>
<p>您可以使用自定义配置创建axios的新实例。</p>
<p>axios.create（[config]）</p>
<div>
<pre class="prettyprint linenums">var instance = axios.create({<br />
　　baseURL: 'https://some-domain.com/api/',<br />
　　timeout: 1000,<br />
　　headers: {'X-Custom-Header': 'foobar'}<br />
});</pre>
</div>
<p>示例（自定义实例$$，替代axios，统一url）：</p>
<div>
<pre class="prettyprint linenums">&lt;!DOCTYPE html&gt;<br />
&lt;html&gt;

    &lt;head&gt;<br />
        &lt;meta charset="UTF-8"&gt;<br />
        &lt;title&gt;axios&lt;/title&gt;<br />
    &lt;/head&gt;

    &lt;body&gt;<br />
        &lt;div id="vm"&gt;<br />
            &lt;button type="button" @click="all"&gt;all请求（并发请求）&lt;/button&gt;<br />
            &lt;button type="button" @click="remove"&gt;delete请求（删除数据）&lt;/button&gt;<br />
            &lt;h3&gt;{{msg}}&lt;/h3&gt;<br />
        &lt;/div&gt;<br />
        &lt;script src="../js/vue.js" type="text/javascript" charset="utf-8"&gt;&lt;/script&gt;<br />
        &lt;script src="../js/axios/axios.min.js" type="text/javascript" charset="utf-8"&gt;&lt;/script&gt;<br />
        &lt;script type="text/javascript"&gt;

            //创建自定义的axios实例<br />
            var $$=axios.create({<br />
                baseURL:"http://localhost:8080/mvc08/emps/"<br />
            });

            console.log($$);

            var vm = new Vue({<br />
                el: "#vm",<br />
                data: {<br />
                    msg: ""<br />
                },<br />
                methods: {<br />
                    all: function() {<br />
                        //获得用户对象1<br />
                        var getUser1 = function() {<br />
                            return $$({<br />
                                url:"1",<br />
                                method:"get"<br />
                            });<br />
                        };<br />
                        //获得用户对象2<br />
                        var getUser2 = function() {<br />
                            return $$.get("24");<br />
                        };<br />
                        //并发请求处理结果<br />
                        axios.all([getUser1(), getUser2()])<br />
                            .then(axios.spread(function(response1, response2) {<br />
                                var result = "";<br />
                                result += JSON.stringify(response1.data.data);<br />
                                result += JSON.stringify(response2.data.data);<br />
                                vm.msg = result;<br />
                            }))<br />
                            .catch(function(error) {<br />
                                console.log(error);<br />
                            });<br />
                    },<br />
                    remove: function() {<br />
                        $$.delete("2")<br />
                        .then(r=&gt;vm.msg=r.data.data)<br />
                        .catch(e=&gt;console.log(e));<br />
                    }<br />
                }<br />
            });<br />
        &lt;/script&gt;<br />
    &lt;/body&gt;

&lt;/html&gt;</pre>
</div>
<p>结果：</p>
<p><img referrerpolicy="no-referrer"src="https://images2017.cnblogs.com/blog/63651/201801/63651-20180104100138987-125066408.png" /></p>
<h3>1.3.6、实例方法</h3>
<p>可用的实例方法如下所示。 指定的配置将与实例配置合并。</p>
<div>
<pre class="prettyprint linenums">axios＃request（config）<br />
axios＃get（url [，config]）<br />
axios＃delete（url [，config]）<br />
axios＃head（url [，config]）<br />
axios＃post（url [，data [，config]]）<br />
axios＃put（url [，data [，config]]）<br />
axios＃patch（url [，data [，config]]）</pre>
</div>
<h3>1.3.7、请求配置</h3>
<p>这些是用于发出请求的可用配置选项。 只有url是必需的。 如果未指定方法，请求将默认为GET。</p>
<div>
<pre class="prettyprint linenums">{<br />
// `url`是将用于请求的服务器URL<br />
url: '/user',

// `method`是发出请求时使用的请求方法<br />
method: 'get', // 默认

// `baseURL`将被添加到`url`前面，除非`url`是绝对的。<br />
// 可以方便地为 axios 的实例设置`baseURL`，以便将相对 URL 传递给该实例的方法。<br />
baseURL: 'https://some-domain.com/api/',

// `transformRequest`允许在请求数据发送到服务器之前对其进行更改<br />
// 这只适用于请求方法'PUT'，'POST'和'PATCH'<br />
// 数组中的最后一个函数必须返回一个字符串，一个 ArrayBuffer或一个 Stream

transformRequest: [function (data) {<br />
// 做任何你想要的数据转换

return data;<br />
}],

// `transformResponse`允许在 then / catch之前对响应数据进行更改<br />
transformResponse: [function (data) {<br />
// Do whatever you want to transform the data

return data;<br />
}],

// `headers`是要发送的自定义 headers<br />
headers: {'X-Requested-With': 'XMLHttpRequest'},

// `params`是要与请求一起发送的URL参数<br />
// 必须是纯对象或URLSearchParams对象<br />
params: {<br />
ID: 12345<br />
},

// `paramsSerializer`是一个可选的函数，负责序列化`params`<br />
// (e.g. https://www.npmjs.com/package/qs, http://api.jquery.com/jquery.param/)<br />
paramsSerializer: function(params) {<br />
return Qs.stringify(params, {arrayFormat: 'brackets'})<br />
},

// `data`是要作为请求主体发送的数据<br />
// 仅适用于请求方法&ldquo;PUT&rdquo;，&ldquo;POST&rdquo;和&ldquo;PATCH&rdquo;<br />
// 当没有设置`transformRequest`时，必须是以下类型之一：<br />
// - string, plain object, ArrayBuffer, ArrayBufferView, URLSearchParams<br />
// - Browser only: FormData, File, Blob<br />
// - Node only: Stream<br />
data: {<br />
firstName: 'Fred'<br />
},

// `timeout`指定请求超时之前的毫秒数。<br />
// 如果请求的时间超过'timeout'，请求将被中止。<br />
timeout: 1000,

// `withCredentials`指示是否跨站点访问控制请求<br />
// should be made using credentials<br />
withCredentials: false, // default

// `adapter'允许自定义处理请求，这使得测试更容易。<br />
// 返回一个promise并提供一个有效的响应（参见[response docs]（＃response-api））<br />
adapter: function (config) {<br />
/* ... */<br />
},

// `auth'表示应该使用 HTTP 基本认证，并提供凭据。<br />
// 这将设置一个`Authorization'头，覆盖任何现有的`Authorization'自定义头，使用`headers`设置。<br />
auth: {<br />
username: 'janedoe',<br />
password: 's00pers3cret'<br />
},

// &ldquo;responseType&rdquo;表示服务器将响应的数据类型<br />
// 包括 'arraybuffer', 'blob', 'document', 'json', 'text', 'stream'<br />
responseType: 'json', // default

//`xsrfCookieName`是要用作 xsrf 令牌的值的cookie的名称<br />
xsrfCookieName: 'XSRF-TOKEN', // default

// `xsrfHeaderName`是携带xsrf令牌值的http头的名称<br />
xsrfHeaderName: 'X-XSRF-TOKEN', // default

// `onUploadProgress`允许处理上传的进度事件<br />
onUploadProgress: function (progressEvent) {<br />
// 使用本地 progress 事件做任何你想要做的<br />
},

// `onDownloadProgress`允许处理下载的进度事件<br />
onDownloadProgress: function (progressEvent) {<br />
// Do whatever you want with the native progress event<br />
},

// `maxContentLength`定义允许的http响应内容的最大大小<br />
maxContentLength: 2000,

// `validateStatus`定义是否解析或拒绝给定的promise<br />
// HTTP响应状态码。如果`validateStatus`返回`true`（或被设置为`null` promise将被解析;否则，promise将被<br />
// 拒绝。<br />
validateStatus: function (status) {<br />
return status &gt;= 200 &amp;&amp; status &lt; 300; // default<br />
},

// `maxRedirects`定义在node.js中要遵循的重定向的最大数量。<br />
// 如果设置为0，则不会遵循重定向。<br />
maxRedirects: 5, // 默认

// `httpAgent`和`httpsAgent`用于定义在node.js中分别执行http和https请求时使用的自定义代理。<br />
// 允许配置类似`keepAlive`的选项，<br />
// 默认情况下不启用。<br />
httpAgent: new http.Agent({ keepAlive: true }),<br />
httpsAgent: new https.Agent({ keepAlive: true }),

// 'proxy'定义代理服务器的主机名和端口<br />
// `auth`表示HTTP Basic auth应该用于连接到代理，并提供credentials。<br />
// 这将设置一个`Proxy-Authorization` header，覆盖任何使用`headers`设置的现有的`Proxy-Authorization` 自定义 headers。<br />
proxy: {<br />
host: '127.0.0.1',<br />
port: 9000,<br />
auth: : {<br />
username: 'mikeymike',<br />
password: 'rapunz3l'<br />
}<br />
},

// &ldquo;cancelToken&rdquo;指定可用于取消请求的取消令牌<br />
// (see Cancellation section below for details)<br />
cancelToken: new CancelToken(function (cancel) {<br />
})<br />
}</pre>
</div>
<p>使用 then 时，您将收到如下响应：</p>
<div>
<pre class="prettyprint linenums">axios.get('/user/12345')<br />
.then(function(response) {<br />
　　console.log(response.data);<br />
　　console.log(response.status);<br />
　　console.log(response.statusText);<br />
　　console.log(response.headers);<br />
　　console.log(response.config);<br />
});</pre>
</div>
<h2>1.4、配置默认值</h2>
<p>您可以指定将应用于每个请求的配置默认值。</p>
<h3>1.4.1、全局axios默认值</h3>
<div>
<pre class="prettyprint linenums">axios.defaults.baseURL = 'https://api.example.com';<br />
axios.defaults.headers.common['Authorization'] = AUTH_TOKEN;<br />
axios.defaults.headers.post['Content-Type'] = 'application/x-www-form-urlencoded';</pre>
</div>
<h3>1.4.2、自定义实例默认值</h3>
<div>
<pre class="prettyprint linenums">//在创建实例时设置配置默认值<br />
var instance = axios.create（{<br />
　　baseURL：'https://api.example.com'<br />
}）;

//在实例创建后改变默认值<br />
instance.defaults.headers.common ['Authorization'] = AUTH_TOKEN;</pre>
</div>
<h3>1.4.3、配置优先级顺序</h3>
<p>配置将与优先顺序合并。 顺序是lib / defaults.js中的库默认值，然后是实例的defaults属性，最后是请求的config参数。 后者将优先于前者。 这里有一个例子。</p>
<div>
<pre class="prettyprint linenums">//使用库提供的配置默认值创建实例<br />
//此时，超时配置值为`0`，这是库的默认值<br />
var instance = axios.create（）;

//覆盖库的超时默认值<br />
//现在所有请求将在超时前等待2.5秒<br />
instance.defaults.timeout = 2500;

//覆盖此请求的超时，因为它知道需要很长时间<br />
instance.get（'/ longRequest'，{<br />
timeout：5000<br />
}）;</pre>
</div>
<h2>1.5、拦截器</h2>
<p>你可以截取请求或响应在被 then 或者 catch 处理之前</p>
<div>
<pre class="prettyprint linenums">//添加请求拦截器<br />
axios.interceptors.request.use（function（config）{<br />
//在发送请求之前做某事<br />
return config;<br />
}，function（error）{<br />
//请求错误时做些事<br />
return Promise.reject（error）;<br />
}）;

//添加响应拦截器<br />
axios.interceptors.response.use（function（response）{<br />
//对响应数据做些事<br />
return response;<br />
}，function（error）{<br />
//请求错误时做些事<br />
return Promise.reject（error）;<br />
}）;</pre>
</div>
<p>如果你以后可能需要删除拦截器。</p>
<div>
<pre class="prettyprint linenums">var myInterceptor = axios.interceptors.request.use(function () {/*...*/});<br />
axios.interceptors.request.eject(myInterceptor);</pre>
</div>
<p>你可以将拦截器添加到axios的自定义实例。</p>
<div>
<pre class="prettyprint linenums">var instance = axios.create();<br />
instance.interceptors.request.use(function () {/*...*/});</pre>
</div>
<h2>1.6、处理错误</h2>
<div>
<pre class="prettyprint linenums">axios.get（'/ user / 12345'）<br />
.catch（function（error）{<br />
if（error.response）{<br />
    //请求已发出，但服务器使用状态代码进行响应<br />
    //落在2xx的范围之外<br />
    console.log（error.response.data）;<br />
    console.log（error.response.status）;<br />
    console.log（error.response.headers）;<br />
} else {<br />
    //在设置触发错误的请求时发生了错误<br />
    console.log（'Error'，error.message）;<br />
}}<br />
    console.log（error.config）;<br />
}）;</pre>
</div>
<p>您可以使用validateStatus配置选项定义自定义HTTP状态码错误范围。</p>
<div>
<pre class="prettyprint linenums">axios.get（'/ user / 12345'，{<br />
　　validateStatus：function（status）{<br />
　　return status &lt; 500; //仅当状态代码大于或等于500时拒绝<br />
　　}}<br />
}）</pre>
</div>
<h2>1.7、取消令牌（Cancellation）</h2>
<p>您可以使用取消令牌取消请求。</p>
<p>axios cancel token API基于可取消的promise提议，目前处于阶段1。<br />您可以使用CancelToken.source工厂创建一个取消令牌，如下所示：</p>
<div>
<pre class="prettyprint linenums">var CancelToken = axios.CancelToken;<br />
var source = CancelToken.source（）;

axios.get('/user/12345', {<br />
cancelToken: source.token<br />
}).catch(function(thrown) {<br />
if (axios.isCancel(thrown)) {<br />
console.log('Request canceled', thrown.message);<br />
} else {<br />
// 处理错误<br />
}<br />
});

//取消请求（消息参数是可选的）<br />
source.cancel（'操作被用户取消。'）;</pre>
</div>
<p>您还可以通过将执行器函数传递给CancelToken构造函数来创建取消令牌：</p>
<div>
<pre class="prettyprint linenums">var CancelToken = axios.CancelToken;<br />
var cancel;

axios.get（'/ user / 12345'，{<br />
cancelToken：new CancelToken（function executor（c）{<br />
　　　　//一个执行器函数接收一个取消函数作为参数<br />
　　　　cancel = c;<br />
　　}）<br />
}）;

// 取消请求<br />
clear();</pre>
</div>
<p>注意：您可以使用相同的取消令牌取消几个请求。</p>
<h2>1.8、使用application / x-www-form-urlencoded格式</h2>
<p>默认情况下，axios将JavaScript对象序列化为JSON。 要以应用程序/ x-www-form-urlencoded格式发送数据，您可以使用以下选项之一。</p>
<pre class="prettyprint linenums">axios.defaults.headers.post['Content-Type'] = 'application/x-www-form-urlencoded';</pre>
<h3>1.8.1、浏览器中</h3>
<p>在浏览器中，您可以使用URLSearchParams API，如下所示：</p>
<div>
<pre class="prettyprint linenums">var params = new URLSearchParams();<br />
params.append('param1', 'value1');<br />
params.append('param2', 'value2');<br />
axios.post('/foo', params);</pre>
</div>
<p>请注意，所有浏览器都不支持URLSearchParams，但是有一个polyfill可用（确保polyfill全局环境）。<br />或者，您可以使用qs库对数据进行编码：</p>
<div>
<pre class="prettyprint linenums">var qs = require('qs');<br />
axios.post('/foo', qs.stringify({ 'bar': 123 });</pre>
</div>
<h3>1.8.2、Node.js中</h3>
<p>在node.js中，可以使用querystring模块，如下所示：</p>
<div>
<pre class="prettyprint linenums">var querystring = require('querystring');<br />
axios.post('http://something.com/', querystring.stringify({ foo: 'bar' });</pre>
</div>
<p>你也可以使用qs库。</p>
<h2>2.9、Promise</h2>
<p>axios 依赖本机要支持ES6 Promise实现。 如果您的环境不支持ES6 Promises，您可以使用polyfill。</p>
<h2>1.10、TypeScript</h2>
<p>axios包括TypeScript定义。</p>
<div>
<pre class="prettyprint linenums">import axios from 'axios';<br />
axios.get('/user?ID=12345');</pre>
</div>
<p>axios在很大程度上受到Angular提供的$http服务的启发。 最终，axios努力提供一个在Angular外使用的独立的$http-like服务。</p>
<h1>二、Lodash</h1>
<p>Lodash是一个具有一致接口、模块化、高性能等特性的 JavaScript 工具库。它内部封装了诸多对字符串、数组、对象等常见数据类型的处理函数，其中部分是目前 ECMAScript 尚未制定的规范，但同时被业界所认可的辅助函数。目前每天使用 npm 安装 Lodash 的数量在百万级以上，这在一定程度上证明了其代码的健壮性，值得我们在项目中一试。</p>
<p><img referrerpolicy="no-referrer"src="https://images2017.cnblogs.com/blog/63651/201801/63651-20180103212401331-767361982.png" /></p>
<p>官网：<a href="https://lodash.com/" rel="external nofollow noreferrer">https://lodash.com/</a></p>
<p>中文文档：<a href="http://www.css88.com/doc/lodash/" rel="external nofollow noreferrer">http://www.css88.com/doc/lodash/</a></p>
<p>英文帮助：<a href="https://lodash.com/docs/" rel="external nofollow noreferrer">https://lodash.com/docs/</a></p>
<p>GitHub：<a href="https://github.com/lodash/" rel="external nofollow noreferrer">https://github.com/lodash/</a></p>
<h2>2.1、下载</h2>
<ul><li><a href="https://raw.githubusercontent.com/lodash/lodash/4.17.4/dist/lodash.core.js" rel="external nofollow noreferrer">Core build</a>&nbsp;(<a href="https://raw.githubusercontent.com/lodash/lodash/4.17.4/dist/lodash.core.min.js" rel="external nofollow noreferrer">~4kB gzipped</a>)</li>
<li><a href="https://raw.githubusercontent.com/lodash/lodash/4.17.4/dist/lodash.js" rel="external nofollow noreferrer">Full build</a>&nbsp;(<a href="https://raw.githubusercontent.com/lodash/lodash/4.17.4/dist/lodash.min.js" rel="external nofollow noreferrer">~24kB gzipped</a>)</li>
<li><a href="https://www.jsdelivr.com/projects/lodash" rel="external nofollow noreferrer">CDN copies</a></li></ul>
<p>CDN引用地址：https://cdn.jsdelivr.net/npm/lodash@4.17.4/lodash.min.js</p>
<h2>2.2、安装</h2>
<p>浏览器:</p>
<div>
<pre class="prettyprint linenums">&lt;script src="lodash.js"&gt;&lt;/script&gt;<br />
//或CDN<br />
&lt;script scr="https://cdn.jsdelivr.net/npm/lodash@4.17.4/lodash.min.js"&gt;&lt;/script&gt;</pre>
</div>
<p>用npm:</p>
<div>
<pre class="prettyprint linenums">$ npm i -g npm<br />
$ npm i --save lodash</pre>
</div>
<p>Nodejs:</p>
<div>
<pre class="prettyprint linenums">// Load the full build.<br />
var _ = require('lodash');<br />
// Load the core build.<br />
var _ = require('lodash/core');<br />
// Load the FP build for immutable auto-curried iteratee-first data-last methods.<br />
var fp = require('lodash/fp');

// Load method categories.<br />
var array = require('lodash/array');<br />
var object = require('lodash/fp/object');

// Cherry-pick methods for smaller browserify/rollup/webpack bundles.<br />
var at = require('lodash/at');<br />
var curryN = require('lodash/fp/curryN');</pre>
</div>
<h2>2.3、模块组成</h2>
<p>Lodash 提供的辅助函数主要分为以下几类，函数列表和用法实例请查看 Lodash 的官方文档：</p>
<p>Array，适用于数组类型，比如填充数据、查找元素、数组分片等操作</p>
<p>Collection，适用于数组和对象类型，部分适用于字符串，比如分组、查找、过滤等操作</p>
<p>Function，适用于函数类型，比如节流、延迟、缓存、设置钩子等操作</p>
<p>Lang，普遍适用于各种类型，常用于执行类型判断和类型转换</p>
<p>Math，适用于数值类型，常用于执行数学运算</p>
<p>Number，适用于生成随机数，比较数值与数值区间的关系</p>
<p>Object，适用于对象类型，常用于对象的创建、扩展、类型转换、检索、集合等操作</p>
<p>Seq，常用于创建链式调用，提高执行性能（惰性计算）</p>
<p>String，适用于字符串类型</p>
<p>lodash/fp 模块提供了更接近函数式编程的开发方式，其内部的函数经过包装，具有immutable、auto-curried、iteratee-first、data-last（官方介绍）等特点</p>
<h2>2.4、Lodash快速入门实例</h2>
<h3>2.4.1. N 次循环</h3>
<div>
<pre class="prettyprint linenums">// 1. Basic for loop.<br />
for(var i = 0; i &lt; 5; i++) {<br />
// ...<br />
}

// 2. Using Array's join and split methods<br />
Array.apply(null, Array(5)).forEach(function(){<br />
// ...<br />
});

// Lodash<br />
_.times(5, function(){<br />
// ...<br />
});</pre>
</div>
<p>for 语句是执行循环的不二选择，Array.apply 也可以模拟循环，但在上面代码的使用场景下，_.times() 的解决方式更加简洁和易于理解。</p>
<p>示例：</p>
<div>
<pre class="prettyprint linenums">&lt;!DOCTYPE html&gt;<br />
&lt;html&gt;

    &lt;head&gt;<br />
        &lt;meta charset="UTF-8"&gt;<br />
        &lt;title&gt;Lodash&lt;/title&gt;<br />
    &lt;/head&gt;

    &lt;body&gt;<br />
        &lt;div id="vm"&gt;

        &lt;/div&gt;<br />
        &lt;script src="../js/vue.js" type="text/javascript" charset="utf-8"&gt;&lt;/script&gt;<br />
        &lt;script src="../js/lodash/lodash.min.js" type="text/javascript" charset="utf-8"&gt;&lt;/script&gt;<br />
        &lt;script type="text/javascript"&gt;<br />
            var vm = new Vue({<br />
                el: "#vm",<br />
                data: {<br />
                    msg: ""<br />
                },<br />
                methods: {

                }<br />
            });

            var log = function(str) {<br />
                console.log(str);<br />
            }

            log(_.times(5));<br />
            log(_.times(5, String));<br />
            log(_.times(5, _.constant(0)));<br />
            log(_.times(5, _.constant(true)));<br />
            var a5=_.times(5, function(v) {<br />
                return v+10;<br />
            })<br />
            log(a5);<br />
        &lt;/script&gt;<br />
    &lt;/body&gt;

&lt;/html&gt;</pre>
</div>
<p>结果：</p>
<p><img referrerpolicy="no-referrer"src="https://images2017.cnblogs.com/blog/63651/201801/63651-20180104141438643-161184650.png" /></p>
<h3>2.4.2. 深层查找属性值</h3>
<div>
<pre class="prettyprint linenums">// Fetch the name of the first pet from each owner<br />
var ownerArr = [{<br />
"owner": "Colin",<br />
"pets": [{"name":"dog1"}, {"name": "dog2"}]<br />
}, {<br />
"owner": "John",<br />
"pets": [{"name":"dog3"}, {"name": "dog4"}]<br />
}];

// Array's map method.<br />
ownerArr.map(function(owner){<br />
　　return owner.pets[0].name;<br />
});

// Lodash<br />
_.map(ownerArr, 'pets[0].name');</pre>
</div>
<p>_.map 方法是对原生 map 方法的改进，其中使用 pets[0].name 字符串对嵌套数据取值的方式简化了很多冗余的代码，非常类似使用 jQuery 选择 DOM 节点 ul &gt; li &gt; a，对于前端开发者来说有种久违的亲切感。</p>
<p>示例：</p>
<div>
<pre class="prettyprint linenums">&lt;!DOCTYPE html&gt;<br />
&lt;html&gt;<br />
    &lt;head&gt;<br />
        &lt;meta charset="UTF-8"&gt;<br />
        &lt;title&gt;Lodash&lt;/title&gt;<br />
    &lt;/head&gt;<br />
    &lt;body&gt;<br />
        &lt;script src="../js/lodash/lodash.min.js" type="text/javascript" charset="utf-8"&gt;&lt;/script&gt;<br />
        &lt;script type="text/javascript"&gt;<br />
            var log = function(str) {<br />
                if(typeof str == "object")<br />
                {<br />
                    console.log(JSON.stringify(str));<br />
                }<br />
                console.log(str);<br />
            }

            var arr = [{<br />
                "owner": "Colin",<br />
                "pets": [{<br />
                    "name": "dog1"<br />
                }, {<br />
                    "name": "dog2"<br />
                }]<br />
            }, {<br />
                "owner": "John",<br />
                "pets": [{<br />
                    "name": "dog3"<br />
                }, {<br />
                    "name": "dog4"<br />
                }]<br />
            }];

            log(_.map(arr,"pets"));<br />
            log(_.map(arr,"owner"));<br />
            log(_.map(arr,"pets[1].name"));<br />
            log(_.map(arr,o=&gt;o.pets[1].name+":)"));<br />
        &lt;/script&gt;<br />
    &lt;/body&gt;

&lt;/html&gt;</pre>
</div>
<p>结果：</p>
<p><img referrerpolicy="no-referrer"src="https://images2017.cnblogs.com/blog/63651/201801/63651-20180104142358049-445516449.png" /></p>
<h3>2.4.3. 个性化数组</h3>
<div>
<pre class="prettyprint linenums">// Array's map method.<br />
Array.apply(null, Array(6)).map(function(item, index){<br />
return "ball_" + index;<br />
});

// Lodash<br />
_.times(6, _.uniqueId.bind(null, 'ball_'));

// Lodash<br />
_.times(6, _.partial(_.uniqueId, 'ball_'));<br />
// eg. [ball_0, ball_1, ball_2, ball_3, ball_4, ball_5]</pre>
</div>
<p>在上面的代码中，我们要创建一个初始值不同、长度为 6 的数组，其中 _.uniqueId 方法用于生成独一无二的标识符（递增的数字，在程序运行期间保持独一无二），_partial 方法是对 bind 的封装。</p>
<p>示例：</p>
<div>
<pre class="prettyprint linenums">&lt;!DOCTYPE html&gt;<br />
&lt;html&gt;<br />
    &lt;head&gt;<br />
        &lt;meta charset="UTF-8"&gt;<br />
        &lt;title&gt;Lodash&lt;/title&gt;<br />
    &lt;/head&gt;<br />
    &lt;body&gt;<br />
        &lt;script src="../js/lodash/lodash.min.js" type="text/javascript" charset="utf-8"&gt;&lt;/script&gt;<br />
        &lt;script type="text/javascript"&gt;<br />
            var log = function(str) {<br />
                if(typeof str == "object")<br />
                {<br />
                    console.log(JSON.stringify(str));<br />
                }<br />
                console.log(str);<br />
            }<br />
            //产生唯一编号<br />
            log(_.uniqueId());<br />
            log(_.uniqueId("gdnf_"));

            //封装函数<br />
            function greet(greeting,name){<br />
                return greeting +" " +name;<br />
            }<br />
            log(greet("hello","tom"));

            var sayhello=_.partial(greet,'hello');<br />
            var sayhi=_.partial(greet,'hi');

            log(sayhello('mark'));<br />
            log(sayhi('rose'));

            //综合<br />
            var array=_.times(5,_.partial(_.uniqueId,'ball_'));<br />
            log(array);<br />
        &lt;/script&gt;<br />
    &lt;/body&gt;

&lt;/html&gt;</pre>
</div>
<p>结果：</p>
<p><img referrerpolicy="no-referrer"src="https://images2017.cnblogs.com/blog/63651/201801/63651-20180104145012034-1458389985.png" /></p>
<h3>2.4.4. 深拷贝</h3>
<div>
<pre class="prettyprint linenums">var objA = {<br />
"name": "colin"<br />
}

// Normal method? Too long. See Stackoverflow for solution:<br />
// http://stackoverflow.com/questions/4459928/how-to-deep-clone-in-javascript

// Lodash<br />
var objB = _.cloneDeep(objA);<br />
objB === objA // false</pre>
</div>
<p>JavaScript 没有直接提供深拷贝的函数，但我们可以用其他函数来模拟，比如 JSON.parse(JSON.stringify(objectToClone))，但这种方法要求对象中的属性值不能是函数。Lodash 中的 _.cloneDeep 函数封装了深拷贝的逻辑，用起来更加简洁。</p>
<p>示例：</p>
<div>
<pre class="prettyprint linenums">&lt;!DOCTYPE html&gt;<br />
&lt;html&gt;

    &lt;head&gt;<br />
        &lt;meta charset="UTF-8"&gt;<br />
        &lt;title&gt;Lodash&lt;/title&gt;<br />
    &lt;/head&gt;

    &lt;body&gt;<br />
        &lt;script src="../js/lodash/lodash.min.js" type="text/javascript" charset="utf-8"&gt;&lt;/script&gt;<br />
        &lt;script type="text/javascript"&gt;<br />
            var log = function(str) {<br />
                if(typeof str == "object") {<br />
                    console.log(JSON.stringify(str));<br />
                }<br />
                console.log(str);<br />
            }<br />
            var obj0={address:"中国珠海"};<br />
            var obj1 = {<br />
                id: 1,<br />
                name: "rose",<br />
                position:obj0<br />
            };<br />
            log("引用");<br />
            //引用<br />
            var obj2=obj1;<br />
            log(obj2==obj1);<br />
            log("浅拷贝");<br />
            //浅拷贝<br />
            var obj3=_.clone(obj1);<br />
            log(obj3==obj1);<br />
            log(obj3===obj1);<br />
            log(obj3.position===obj1.position);<br />
            log("深拷贝");<br />
            //深拷贝<br />
            var obj4=_.cloneDeep(obj1);<br />
            log(obj4==obj1);<br />
            log(obj4===obj1);<br />
            log(obj4.position===obj1.position);<br />
        &lt;/script&gt;<br />
    &lt;/body&gt;

&lt;/html&gt;</pre>
</div>
<p>结果：</p>
<p><img referrerpolicy="no-referrer"src="https://images2017.cnblogs.com/blog/63651/201801/63651-20180104150202987-552225726.png" /></p>
<h3>2.4.5. 随机数</h3>
<div>
<pre class="prettyprint linenums">// Naive utility method<br />
function getRandomNumber(min, max){<br />
return Math.floor(Math.random() * (max - min + 1)) + min;<br />
}

getRandomNumber(15, 20);

// Lodash<br />
_.random(15, 20);</pre>
</div>
<p>Lodash 的随机数生成函数更贴近实际开发，ECMAScript 的随机数生成函数是底层必备的接口，两者都不可或缺。此外，使用 _.random(15, 20, true) 还可以在 15 到 20 之间生成随机的浮点数。</p>
<p>示例：</p>
<div>
<pre class="prettyprint linenums">&lt;!DOCTYPE html&gt;<br />
&lt;html&gt;

    &lt;head&gt;<br />
        &lt;meta charset="UTF-8"&gt;<br />
        &lt;title&gt;Lodash&lt;/title&gt;<br />
    &lt;/head&gt;

    &lt;body&gt;<br />
        &lt;script src="../js/lodash/lodash.min.js" type="text/javascript" charset="utf-8"&gt;&lt;/script&gt;<br />
        &lt;script type="text/javascript"&gt;<br />
            var log = function(str) {<br />
                if(typeof str == "object") {<br />
                    console.log(JSON.stringify(str));<br />
                }<br />
                console.log(str);<br />
            }<br />
            var obj0={address:"中国珠海"};<br />
            var obj1 = {<br />
                id: 1,<br />
                name: "rose",<br />
                position:obj0<br />
            };

            var arr=_.times(10,function(){<br />
                return _.random(1,100);<br />
            });<br />
            log(arr);<br />
        &lt;/script&gt;<br />
    &lt;/body&gt;

&lt;/html&gt;</pre>
</div>
<p>结果：</p>
<p><img referrerpolicy="no-referrer"src="https://images2017.cnblogs.com/blog/63651/201801/63651-20180104150525831-658758714.png" /></p>
<h3>2.4.6. 对象扩展</h3>
<div>
<pre class="prettyprint linenums">// Adding extend function to Object.prototype<br />
Object.prototype.extend = function(obj) {<br />
for (var i in obj) {<br />
if (obj.hasOwnProperty(i)) {<br />
this[i] = obj[i];<br />
}<br />
}<br />
};

var objA = {"name": "colin", "car": "suzuki"};<br />
var objB = {"name": "james", "age": 17};

objA.extend(objB);<br />
objA; // {"name": "james", "age": 17, "car": "suzuki"};

// Lodash<br />
_.assign(objA, objB);</pre>
</div>
<p>_.assign 是浅拷贝，和 ES6 新增的 Ojbect.assign 函数功能一致（建议优先使用 Object.assign）。</p>
<p>示例：</p>
<div>
<pre class="prettyprint linenums">&lt;!DOCTYPE html&gt;<br />
&lt;html&gt;

    &lt;head&gt;<br />
        &lt;meta charset="UTF-8"&gt;<br />
        &lt;title&gt;Lodash&lt;/title&gt;<br />
    &lt;/head&gt;

    &lt;body&gt;<br />
        &lt;script src="../js/lodash/lodash.min.js" type="text/javascript" charset="utf-8"&gt;&lt;/script&gt;<br />
        &lt;script type="text/javascript"&gt;<br />
            var log = function(str) {<br />
                if(typeof str == "object") {<br />
                    console.log(JSON.stringify(str));<br />
                }<br />
                console.log(str);<br />
            }<br />
            var obj0 = {<br />
                address: "中国珠海"<br />
            };<br />
            var obj1 = {<br />
                id: 1,<br />
                name: "rose",<br />
                position: obj0<br />
            };

            var x = {<br />
                a: 1,<br />
                b: 2,<br />
                c: 3<br />
            };<br />
            var y = {<br />
                b: 5,<br />
                c: 6,<br />
                d: 7<br />
            };<br />
            //用y扩展x<br />
            _.assign(x,y);<br />
            log(x);  //x被修改了<br />
            log(y);<br />
        &lt;/script&gt;<br />
    &lt;/body&gt;<br />
&lt;/html&gt;</pre>
</div>
<p>结果：</p>
<p><img referrerpolicy="no-referrer"src="https://images2017.cnblogs.com/blog/63651/201801/63651-20180104151102003-2066478515.png" /></p>
<h3>2.4.7. 筛选属性</h3>
<div>
<pre class="prettyprint linenums">// Naive method: Remove an array of keys from object<br />
Object.prototype.remove = function(arr) {<br />
var that = this;<br />
arr.forEach(function(key){<br />
delete(that[key]);<br />
});<br />
};

var objA = {"name": "colin", "car": "suzuki", "age": 17};

objA.remove(['car', 'age']);<br />
objA; // {"name": "colin"}

// Lodash<br />
objA = _.omit(objA, ['car', 'age']);<br />
// =&gt; {"name": "colin"}<br />
objA = _.omit(objA, 'car');<br />
// =&gt; {"name": "colin", "age": 17};<br />
objA = _.omit(objA, _.isNumber);<br />
// =&gt; {"name": "colin"};</pre>
</div>
<p>大多数情况下，Lodash 所提供的辅助函数都会比原生的函数更贴近开发需求。在上面的代码中，开发者可以使用数组、字符串以及函数的方式筛选对象的属性，并且最终会返回一个新的对象，中间执行筛选时不会对旧对象产生影响。</p>
<div>
<pre class="prettyprint linenums">// Naive method: Returning a new object with selected properties<br />
Object.prototype.pick = function(arr) {<br />
var _this = this;<br />
var obj = {};<br />
arr.forEach(function(key){<br />
obj[key] = _this[key];<br />
});

return obj;<br />
};

var objA = {"name": "colin", "car": "suzuki", "age": 17};

var objB = objA.pick(['car', 'age']);<br />
// {"car": "suzuki", "age": 17}

// Lodash<br />
var objB = _.pick(objA, ['car', 'age']);<br />
// {"car": "suzuki", "age": 17}</pre>
</div>
<p>_.pick 是 _.omit 的相反操作，用于从其他对象中挑选属性生成新的对象。</p>
<p>示例：</p>
<div>
<pre class="prettyprint linenums">&lt;!DOCTYPE html&gt;<br />
&lt;html&gt;

    &lt;head&gt;<br />
        &lt;meta charset="UTF-8"&gt;<br />
        &lt;title&gt;Lodash&lt;/title&gt;<br />
    &lt;/head&gt;

    &lt;body&gt;<br />
        &lt;script src="../js/lodash/lodash.min.js" type="text/javascript" charset="utf-8"&gt;&lt;/script&gt;<br />
        &lt;script type="text/javascript"&gt;<br />
            var log = function(str) {<br />
                if(typeof str == "object") {<br />
                    console.log(JSON.stringify(str));<br />
                }<br />
                console.log(str);<br />
            }<br />
            var obj0 = {<br />
                address: "中国珠海"<br />
            };<br />
            var obj1 = {<br />
                id: 1,<br />
                name: "rose",<br />
                position: obj0<br />
            };

            var student = {<br />
                name: "张三",<br />
                age: 18,<br />
                address: "中国香港"<br />
            };

            //删除属性地址，未修改原数组<br />
            var obj1 = _.omit(student, "address");<br />
            log(obj1);

            var obj2 = _.omit(student, ['age','name']);<br />
            log(obj2);<br />
        &lt;/script&gt;<br />
    &lt;/body&gt;

&lt;/html&gt;</pre>
</div>
<p>结果：</p>
<p><img referrerpolicy="no-referrer"src="https://images2017.cnblogs.com/blog/63651/201801/63651-20180104152133565-470016865.png" /></p>
<h3>2.4.8. 随机元素</h3>
<div>
<pre class="prettyprint linenums">var luckyDraw = ["Colin", "John", "James", "Lily", "Mary"];

function pickRandomPerson(luckyDraw){<br />
var index = Math.floor(Math.random() * (luckyDraw.length -1));<br />
return luckyDraw[index];<br />
}

pickRandomPerson(luckyDraw); // John

// Lodash<br />
_.sample(luckyDraw); // Colin

// Lodash - Getting 2 random item<br />
_.sample(luckyDraw, 2); // ['John','Lily']</pre>
</div>
<p>_.sample 支持随机挑选多个元素并返回新的数组。</p>
<p>示例：</p>
<div>
<pre class="prettyprint linenums">&lt;!DOCTYPE html&gt;<br />
&lt;html&gt;

    &lt;head&gt;<br />
        &lt;meta charset="UTF-8"&gt;<br />
        &lt;title&gt;Lodash&lt;/title&gt;<br />
    &lt;/head&gt;

    &lt;body&gt;<br />
        &lt;script src="../js/lodash/lodash.min.js" type="text/javascript" charset="utf-8"&gt;&lt;/script&gt;<br />
        &lt;script type="text/javascript"&gt;<br />
            var log = function(str) {<br />
                if(typeof str == "object") {<br />
                    console.log(JSON.stringify(str));<br />
                }<br />
                console.log(str);<br />
            }<br />
            var luckyDraw = ["Colin", "John", "James", "Lily", "Mary"];

            //随机获得一个<br />
            log(_.sample(luckyDraw));<br />
            //随机获得多个<br />
            log(_.sampleSize(luckyDraw,2));<br />
        &lt;/script&gt;<br />
    &lt;/body&gt;

&lt;/html&gt;</pre>
</div>
<p>结果：</p>
<p><img referrerpolicy="no-referrer"src="https://images2017.cnblogs.com/blog/63651/201801/63651-20180104152534253-1862461215.png" /></p>
<h3>2.4.9. 针对 JSON.parse 的错误处理</h3>
<div>
<pre class="prettyprint linenums">// Using try-catch to handle the JSON.parse error<br />
function parse(str){<br />
try {<br />
return JSON.parse(str);<br />
}

catch(e) {<br />
return false;<br />
}<br />
}

// With Lodash<br />
function parseLodash(str){<br />
return _.attempt(JSON.parse.bind(null, str));<br />
}

parse('a');<br />
// =&gt; false<br />
parseLodash('a');<br />
// =&gt; Return an error object

parse('{"name": "colin"}');<br />
// =&gt; Return {"name": "colin"}<br />
parseLodash('{"name": "colin"}');<br />
// =&gt; Return {"name": "colin"}</pre>
</div>
<p>如果你在使用 JSON.parse 时没有预置错误处理，那么它很有可能会成为一个定时炸弹，我们不应该默认接收的 JSON 对象都是有效的。try-catch 是最常见的错误处理方式，如果项目中 Lodash，那么可以使用 _.attmpt 替代 try-catch 的方式，当解析 JSON 出错时，该方法会返回一个 Error 对象。</p>
<p>随着 ES6 的普及，Lodash 的功能或多或少会被原生功能所替代，所以使用时还需要进一步甄别，建议优先使用原生函数。</p>
<h2>2.5、更多功能</h2>
<p><img referrerpolicy="no-referrer"src="https://images2017.cnblogs.com/blog/63651/201801/63651-20180103223139971-1576270055.png" /></p>
<p><strong>1)&nbsp;<code>_.map(collection, [iteratee=_.identity], [thisArg])</code></strong></p>
<p>作用：创建一个经过&nbsp;<code>iteratee</code>&nbsp;处理的集合中每一个元素的结果数组. iteratee 会传入3个参数：(value, index|key, collection).</p>
<p>别名（Aliases）：_.collect</p>
<p>参数1): 需要遍历的集合，可以是数组，对象或者字符串.</p>
<p>参数2): 迭代器，可以是函数，对象或者字符串.</p>
<p>参数3): 迭代器中this所绑定的对象.</p>
<p>返回值(Array): 映射后的新数组.</p>
<p>示例:</p>
<div>
<pre class="prettyprint linenums"> function timesThree(n) {<br />
   return n * 3;<br />
 }

 _.map([1, 2], timesThree);<br />
 // =&gt; [3, 6]

 _.map({ 'a': 1, 'b': 2 }, timesThree);<br />
 // =&gt; [3, 6] (iteration order is not guaranteed)

 var users = [<br />
   { 'user': 'barney' },<br />
   { 'user': 'fred' }<br />
 ];

 // using the `_.property` callback shorthand<br />
 _.map(users, 'user');<br />
 // =&gt; ['barney', 'fred']</pre>
</div>
<p><strong>2)&nbsp;<code>_.chunk(array, [size=1])</code></strong></p>
<p>作用：将&nbsp;<code>array</code>&nbsp;拆分成多个&nbsp;<code>size</code>&nbsp;长度的块，把这些块组成一个新数组。 如果&nbsp;<code>array</code>&nbsp;无法被分割成全部等长的块，那么最后剩余的元素将组成一个块.</p>
<p>参数1): 需要被处理的数组.</p>
<p>参数2): 每个块的长度.</p>
<p>返回值(Array): 返回一个包含拆分块数组的新数组（相当于一个二维数组）.</p>
<p>示例:</p>
<div>
<pre class="prettyprint linenums"> _.chunk(['a', 'b', 'c', 'd'], 2);<br />
 // =&gt; [['a', 'b'], ['c', 'd']]

 _.chunk(['a', 'b', 'c', 'd'], 3);<br />
 // =&gt; [['a', 'b', 'c'], ['d']]</pre>
</div>
<p><strong>3)&nbsp;<code>_.compact(array)</code></strong></p>
<p>作用：创建一个新数组并包含原数组中所有的非假值元素。例如&nbsp;<code>false</code>、<code>null</code>、&nbsp;<code>0</code>、<code>""</code>、<code>undefined</code>&nbsp;和&nbsp;<code>NaN</code>&nbsp;都是&ldquo;假值&rdquo;.</p>
<p>参数:&nbsp;需要被过滤的数组.</p>
<p>返回值(Array): 过滤假值后的数组.</p>
<p>示例:</p>
<div>
<pre class="prettyprint linenums"> _.compact([0, 1, false, 2, '', 3]);<br />
 // =&gt; [1, 2, 3]</pre>
</div>
<p><strong>4)&nbsp;<code>_.difference(array, [values])</code></strong></p>
<p>作用：创建一个差异化后的数组，不包括使用&nbsp;<code>SameValueZero</code>&nbsp;方法提供的数组.</p>
<p>参数1): 需要处理的数组.</p>
<p>参数2):&nbsp;数组需要排除掉的值.</p>
<p>返回值(Array): 过滤后的数组.</p>
<p>示例:</p>
<div>
<pre class="prettyprint linenums"> _.difference([1, 2, 3], [4, 2]);<br />
 // =&gt; [1, 3]<br />
 _.difference([1, '2', 3], [4, 2]);<br />
 // =&gt; [1, "2", 3]</pre>
</div>
<p><strong>5)&nbsp;<code>_.drop(array, [n=1])</code></strong></p>
<p>作用：将&nbsp;<code>array</code>&nbsp;中的前&nbsp;<code>n</code>&nbsp;个元素去掉，然后返回剩余的部分.</p>
<p>参数1): 被操作的数组.</p>
<p>参数2): 去掉的元素个数.</p>
<p>返回值(Array): 数组的剩余部分.</p>
<p>示例:</p>
<div>
<pre class="prettyprint linenums"> _.drop([1, 2, 3]);<br />
 // =&gt; [2, 3] 默认是1开始的

 _.drop([1, 2, 3], 2);<br />
 // =&gt; [3]

 _.drop([1, 2, 3], 5);<br />
 // =&gt; []

 _.drop([1, 2, 3], 0);<br />
 // =&gt; [1, 2, 3]</pre>
</div>
<p><strong>6)<code>_.dropRight(array, [n=1])</code></strong></p>
<p>作用：将&nbsp;<code>array</code>&nbsp;尾部的&nbsp;<code>n</code>&nbsp;个元素去除，并返回剩余的部分.</p>
<p>参数1): 需要被处理的数组.</p>
<p>参数2): 去掉的元素个数.</p>
<p>返回值(Array): 数组的剩余部分.</p>
<p>示例:</p>
<div>
<pre class="prettyprint linenums"> _.dropRight([1, 2, 3]);<br />
 // =&gt; [1, 2]

 _.dropRight([1, 2, 3], 2);<br />
 // =&gt; [1]

 _.dropRight([1, 2, 3], 5);<br />
 // =&gt; []

 _.dropRight([1, 2, 3], 0);<br />
 // =&gt; [1, 2, 3]</pre>
</div>
<p><strong>7)<code>_.dropRightWhile(array, [predicate=_.identity], [thisArg])</code></strong></p>
<p>作用：从尾端查询（右数）数组&nbsp;<code>array</code>&nbsp;，第一个不满足<code>predicate</code>&nbsp;条件的元素开始截取数组.</p>
<p>参数1): 需要查询的数组.</p>
<p>参数2):&nbsp;迭代器，可以是函数，对象或者字符串.</p>
<p>参数3):&nbsp;对应&nbsp;<code>predicate</code>&nbsp;属性的值.</p>
<p>返回值(Array):&nbsp;截取元素后的数组.</p>
<p>示例:</p>
<div>
<pre class="prettyprint linenums"> _.dropRightWhile([1, 2, 3], function(n) {<br />
   return n &gt; 1;<br />
 });<br />
 // =&gt; [1]

 var users = [<br />
   { 'user': 'barney',  'active': true },<br />
   { 'user': 'fred',    'active': false },<br />
   { 'user': 'pebbles', 'active': false }<br />
 ];

 // using the `_.matches` callback shorthand<br />
 _.pluck(_.dropRightWhile(users, { 'user': 'pebbles', 'active': false }), 'user');<br />
 // =&gt; ['barney', 'fred']

 // using the `_.matchesProperty` callback shorthand<br />
 _.pluck(_.dropRightWhile(users, 'active', false), 'user');<br />
 // =&gt; ['barney']

 // using the `_.property` callback shorthand<br />
 _.pluck(_.dropRightWhile(users, 'active'), 'user');<br />
 // =&gt; ['barney', 'fred', 'pebbles']</pre>
</div>
<p><strong>8)<code>_.pluck(collection, path)</code></strong></p>
<p>作用：抽取集合中path所指定的路径的属性值.</p>
<p>参数1):&nbsp;需要抽取的数组.</p>
<p>参数2): 需要抽取的属性所对应的路径.</p>
<p>返回值(Array): 抽取的属性值所组成的数组.</p>
<p>示例:</p>
<div>
<pre class="prettyprint linenums"> var users = [<br />
   { 'user': 'barney', 'age': 36 },<br />
   { 'user': 'fred',   'age': 40 }<br />
 ];

 _.pluck(users, 'user');<br />
 // =&gt; ['barney', 'fred']

 var userIndex = _.indexBy(users, 'user');<br />
 _.pluck(userIndex, 'age');<br />
 // =&gt; [36, 40] (iteration order is not guaranteed)</pre>
</div>
<p><strong>9)<code></code><code>_.fill(array, value, [start=0], [end=array.length])</code></strong></p>
<p>作用：使用&nbsp;<code>value</code>&nbsp;值来填充（也就是替换）&nbsp;<code>array</code>，从<code>start</code>位置开始, 到<code>end</code>位置结束（但不包含end位置）.</p>
<p>参数1):&nbsp;需要填充的数组.</p>
<p>参数2):&nbsp;填充&nbsp;<code>array</code>&nbsp;元素的值.</p>
<p>参数3):&nbsp;起始位置（包含）.</p>
<p>参数4):&nbsp;结束位置（不含）.</p>
<p>返回值(Array): 填充后的数组.</p>
<p>示例:</p>
<div>
<pre class="prettyprint linenums"> var array = [1, 2, 3];

 _.fill(array, 'a');<br />
 console.log(array);<br />
 // =&gt; ['a', 'a', 'a']

 _.fill(Array(3), 2);<br />
 // =&gt; [2, 2, 2]

 _.fill([4, 6, 8], '*', 1, 2);<br />
 // =&gt; [4, '*', 8]</pre>
</div>
<p><strong>10)<code></code><code></code><code>_.findIndex(array, [predicate=_.identity], [thisArg])</code></strong></p>
<p>作用：该方法类似&nbsp;<code>_.find</code>，区别是该方法返回的是符合&nbsp;<code>predicate</code>条件的第一个元素的索引，而不是返回元素本身.</p>
<p>参数1):&nbsp;需要搜索的数组.</p>
<p>参数2): 迭代器，可以是函数，对象或者字符串.</p>
<p>参数3):&nbsp;对应&nbsp;<code>predicate</code>&nbsp;属性的值.</p>
<p>返回值(Number): 符合查询条件的元素的索引值, 未找到则返回&nbsp;<code>-1</code>.</p>
<p>示例:</p>
<div>
<pre class="prettyprint linenums"> var users = [<br />
   { 'user': 'barney',  'active': false },<br />
   { 'user': 'fred',    'active': false },<br />
   { 'user': 'pebbles', 'active': true }<br />
 ];

 _.findIndex(users, function(chr) {<br />
   return chr.user == 'barney';<br />
 });<br />
 // =&gt; 0

 // using the `_.matches` callback shorthand<br />
 _.findIndex(users, { 'user': 'fred', 'active': false });<br />
 // =&gt; 1

 // using the `_.matchesProperty` callback shorthand<br />
 _.findIndex(users, 'active', false);<br />
 // =&gt; 0

 // using the `_.property` callback shorthand<br />
 _.findIndex(users, 'active');<br />
 // =&gt; 2</pre>
</div>
<p><strong>11)<code>_.find(collection, [predicate=_.identity], [thisArg])</code></strong></p>
<p>作用：遍历集合中的元素，返回最先经&nbsp;<code>predicate</code>&nbsp;检查为真值的元素. predicate 会传入3个元素：(value, index|key, collection).</p>
<p>参数1):&nbsp;要检索的集合，可以是数组，对象或者字符串.</p>
<p>参数2): 迭代器，可以是函数，对象或者字符串.</p>
<p>参数3): 迭代器中this所绑定的对象.</p>
<p>返回值:&nbsp;匹配元素，否则返回&nbsp;<code>undefined.</code></p>
<p>示例:</p>
<div>
<pre class="prettyprint linenums"> var users = [<br />
   { 'user': 'barney',  'age': 36, 'active': true },<br />
   { 'user': 'fred',    'age': 40, 'active': false },<br />
   { 'user': 'pebbles', 'age': 1,  'active': true }<br />
 ];

 _.find(users, function(o) { return o.age &lt; 40; });<br />
 // =&gt;  'barney'

 // 使用了 `_.matches` 的回调结果<br />
 _.find(users, { 'age': 1, 'active': true });<br />
 // =&gt;  'pebbles'

 // 使用了 `_.matchesProperty` 的回调结果<br />
 _.find(users, ['active', false]);<br />
 // =&gt;  'fred'

 // 使用了 `_.property` 的回调结果<br />
 _.find(users, 'active');<br />
 // =&gt;  'barney'</pre>
</div>
<p><strong>12)<code>_.forEach(collection, [iteratee=_.identity], [thisArg])</code></strong></p>
<p>作用：调用 iteratee 遍历集合中的元素， iteratee 会传入3个参数：(value, index|key, collection)。 如果显式的返回 false ，iteratee 会提前退出.</p>
<p>参数1):&nbsp;需要遍历的集合，可以是数组，对象或者字符串.</p>
<p>参数2): 迭代器，只能是函数.</p>
<p>参数3): 迭代器中this所绑定的对象.</p>
<p>返回值: 遍历后的集合.</p>
<p>示例:</p>
<div>
<pre class="prettyprint linenums"> _([1, 2]).forEach(function(value) {<br />
   console.log(value);<br />
 });<br />
 // =&gt; 输出 `1` 和 `2`

 _.forEach({ 'a': 1, 'b': 2 }, function(value, key) {<br />
   console.log(key);<br />
 });<br />
 // =&gt; 输出 'a' 和 'b' (不保证遍历的顺序)</pre>
</div>
<p><strong>13)_.reduce(collection, [iteratee=_.identity], [accumulator], [thisArg])</strong></p>
<p>作用：通过&nbsp;iteratee&nbsp;遍历集合中的每个元素. 每次返回的值会作为下一次&nbsp;iteratee&nbsp;使用。如果没有提供accumulator，则集合中的第一个元素作为&nbsp;accumulator.&nbsp;iteratee 会传入4个参数：(accumulator, value, index|key, collection).</p>
<p>参数1):&nbsp;需要遍历的集合，可以是数组，对象或者字符串.</p>
<p>参数2): 迭代器，只能是函数.</p>
<p>参数3): 累加器的初始化值.</p>
<p>参数4): 迭代器中this所绑定的对象.</p>
<p>返回值: 累加后的值.</p>
<p>示例:</p>
<div>
<pre class="prettyprint linenums"> _.reduce([1, 2], function(total, n) {<br />
   return total + n;<br />
 });<br />
 // =&gt; 3

 _.reduce({ 'a': 1, 'b': 2 }, function(result, n, key) {<br />
   result[key] = n * 3;<br />
   return result;<br />
 }, {});<br />
 // =&gt; { 'a': 3, 'b': 6 } (iteration order is not guaranteed)</pre>
</div>
<p><strong>14)_.some(collection, [predicate=_.identity], [thisArg])</strong></p>
<p>作用：通过 predicate 检查集合中的元素是否存在任意真值的元素，只要 predicate 返回一次真值，遍历就停止，并返回 true. predicate 会传入3个参数：(value, index|key, collection).</p>
<p>参数1):&nbsp;需要遍历的集合，可以是数组，对象或者字符串.</p>
<p>参数2): 迭代器，可以是函数，对象或字符串.</p>
<p>参数3): 迭代器中this所绑定的对象.</p>
<p>返回值:&nbsp;如果任意元素经 predicate 检查都为真值，则返回true，否则返回 false.</p>
<p>示例:</p>
<div>
<pre class="prettyprint linenums"> _.some([null, 0, 'yes', false], Boolean);<br />
 // =&gt; true

 var users = [<br />
   { 'user': 'barney', 'active': true },<br />
   { 'user': 'fred',   'active': false }<br />
 ];

 // using the `_.matches` callback shorthand<br />
 _.some(users, { 'user': 'barney', 'active': false });<br />
 // =&gt; false

 // using the `_.matchesProperty` callback shorthand<br />
 _.some(users, 'active', false);<br />
 // =&gt; true

 // using the `_.property` callback shorthand<br />
 _.some(users, 'active');<br />
 // =&gt; true</pre>
</div>
<p><strong>15)_.chain(value)</strong></p>
<p>作用：创建一个包含&nbsp;value&nbsp;的&nbsp;lodash&nbsp;对象以开启内置的方法链.方法链对返回数组、集合或函数的方法产生作用，并且方法可以被链式调用.</p>
<p>参数: 需要被包裹成lodash对象的值.</p>
<p>返回值: 新的lodash对象的实例.</p>
<p>示例:</p>
<div>
<pre class="prettyprint linenums"> var users = [<br />
   { 'user': 'barney',  'age': 36 },<br />
   { 'user': 'fred',    'age': 40 },<br />
   { 'user': 'pebbles', 'age': 1 }<br />
 ];

 var youngest = _.chain(users)<br />
   .sortBy('age')<br />
   .map(function(chr) {<br />
     return chr.user + ' is ' + chr.age;<br />
   })<br />
   .first()<br />
   .value();<br />
 // =&gt; 'pebbles is 1'</pre>
</div>
<h1>三、作业</h1>
<p>3.1、使用axios+vue2实现&lt;&lt;迷你任务管理&gt;&gt;，MicTodo，要求与步骤如下：</p>
<ul><li>定义后台服务，请注意跨域，也可以简化成同域服务（模拟后台数据）</li>
<li>实现对任务的添加，修改，删除，查询功能</li>
<li>任务中只需要要这些属性（编号id,名称name,状态state）,当然加上时间更好</li>
<li>使用Lodash完成搜索功能，可以指定要显示的列</li></ul>
<p>3.2、在Loadsh中找到5个关于集合操作的方法，测试通过，不能与上课示例相同</p>
<h1>四、示例下载</h1>
<p><a href="https://git.coding.net/zhangguo5/vue2.git" rel="external nofollow noreferrer">https://git.coding.net/zhangguo5/vue2.git</a></p>
<h1>五、视频</h1>
<p><a href="https://www.bilibili.com/video/av17503637/" rel="external nofollow noreferrer">https://www.bilibili.com/video/av17503637/</a></p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/1q2m60w8.html">&lpar;三&rpar; UART 串口通讯</a>
		</li>
						<li><a href="https://www.batexi.com/a/1q2vrdv8.html">yourphp基本语句</a>
		</li>
						<li><a href="https://www.batexi.com/a/39r3yw49.html">利用PHP读取文件</a>
		</li>
						<li><a href="https://www.batexi.com/a/m8zn04x8.html">java mvc web 项目web&period;xml头改错了，死活加载不上springMvc的jar</a>
		</li>
						<li><a href="https://www.batexi.com/a/jqdyl4vq.html">小甲鱼python视频弟十一讲（课后习题）</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8ke32j8.html">在Linux CentOS上编译并安装Clang 3&period;5&period;0</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlmmr5x9.html">struts2视频学习笔记 24-27（国际化）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxnkn0z8.html">银行支票和汇票中使用的专用字体MICR E13B条形码控件字体</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlmr65e9.html">java数据流</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kp26z59.html">jquery&period;cityselect&period;js基于jQuery&plus;JSON的省市或自定义联动效果</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jz4ge08.html">sublime使用package control安装插件</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kjo1x39.html">sublime快捷方式小结</a>
		</li>
						<li><a href="https://www.batexi.com/a/q25kk4vq.html">Android为TV端助力 apk静默安装</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e4xg7k9.html">路由交换01-----ICMP协议</a>
		</li>
						<li><a href="https://www.batexi.com/a/95g11xzq.html">CUDNN安装</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4pp5rjq.html">e801&period; 创建一个JProgressBar组件</a>
		</li>
						<li><a href="https://www.batexi.com/a/902pkp4q.html">PageUtil 分页</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zkn63d8.html">Python开发一个堡垒机</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o4x3vxq.html">关于Unity中的新手编码技巧</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxl2e6jq.html">sudo命令&colon; 在其他用户下操作root用户权限</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/8meroy6q.html">&num;&num;6&period;2 Neutron计算节点-- openstack pike</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7zjm6j9.html">android应用集成facebook登录</a>
			</li>
						<li><a href="https://www.batexi.com/a/9jzxz748.html">VantPy自动化测试框架</a>
			</li>
						<li><a href="https://www.batexi.com/a/90m1r0j8.html">一道看似dp实则暴力的题 Zombie&amp;&num;39&semi;s Treasure Chest</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1kdr769.html">Hbase 常用命令</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnjldgg8.html">hdu4893 Wow&excl; Such Sequence&excl;</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1kd5629.html">FTP命令具体解释（含操作实例）</a>
			</li>
						<li><a href="https://www.batexi.com/a/90m1jj38.html">poj 2299 Ultra-QuickSort（树状数组求逆序数&plus;离散化）</a>
			</li>
						<li><a href="https://www.batexi.com/a/96p47v48.html">&period;NET Core 已经实现了PHP JIT，现在PHP是&period;NET上的一门开发语言</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnjl5gg8.html">C&num;基础知识 yield与foreach</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
